#include <stdio.h>
#include <stdlib.h>
#include <omp.h>
#include <math.h>
#include "timing.h"

int main(int argc, char *argv[])
{
#define OUTPUT 0

int N = atoi(argv[1]);
int nthreads = atoi(argv[2]);
unsigned long ticksB4, ticksAFT, ticks;
double freq = 2.5e9;
int i;

double *factorials;
factorials = (double *) malloc(N * sizeof(double) );

int *a;
a = (int *) malloc(N * sizeof(int) );
for (i=0; i<N; i++){
	a[i] = rand() % 10 + 1;
}

get_ticks(ticksB4);

double precompute[10];
precompute[0] = 1.;
for(i=1; i<10; i++)
{
	precompute[i] = precompute[i-1] * (double)(i+1);
}


#pragma omp parallel for num_threads(nthreads) private(i)
for (i=0; i<N; i++){
	factorials[i] = precompute[a[i]-1];
}


get_ticks(ticksAFT);
ticks = ticksAFT - ticksB4;

#if OUTPUT
printf("\na:");
for(i=0; i<N; i++) {
	printf(" %d", a[i]);
}
printf("\n\n");

printf("\nresult:");
for(i=0; i<N; i++) {
	printf(" %.3g", factorials[i]);
}
printf("\n\n");
#endif

printf("runtime (s): %g\n\n", ticks/freq);

return 0;
}
